'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.render = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _simplemde = require('simplemde');

var _simplemde2 = _interopRequireDefault(_simplemde);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _ques = require('../lib/ques');

var _ques2 = _interopRequireDefault(_ques);

var _buttons = require('./buttons');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var defaultOptions = {
  autoDownloadFontAwesome: false,
  forceSync: true,
  parsingConfig: {
    allowAtxHeaderWithoutSpace: true
  },
  previewRender: function previewRender(content) {
    return _ques2.default.render(content);
  },
  spellChecker: false,
  toolbar: ['bold', 'italic', 'heading', '|', 'code', 'latex', 'quote', 'unordered-list', 'ordered-list', '|', 'link', 'upload-image', 'upload-file', 'table', '|', 'preview', 'side-by-side', 'fullscreen']
};

var Editor = function (_React$Component) {
  _inherits(Editor, _React$Component);

  function Editor() {
    _classCallCheck(this, Editor);

    return _possibleConstructorReturn(this, (Editor.__proto__ || Object.getPrototypeOf(Editor)).apply(this, arguments));
  }

  _createClass(Editor, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _this2 = this;

      var toolbar = this.props.toolbar || defaultOptions.toolbar;
      if (this.props.guide) {
        toolbar = toolbar.concat(['|', 'guide']);
      }
      var options = Object.assign({}, defaultOptions, {
        element: _reactDom2.default.findDOMNode(this.refs.inputArea),
        toolbar: (0, _buttons.getButtons)(toolbar, {
          guide: this.props.guide,
          lng: this.props.lng,
          uploader: this.props.uploader
        })
      }, this.props.simplemde);
      this.simplemde = new _simplemde2.default(options);
      if (this.props.value) {
        this.text(this.props.value);
      }
      this.simplemde.codemirror.on('change', function () {
        if (_this2.props.onChange) _this2.props.onChange.call(_this2, _this2.text());
      });
    }
  }, {
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps) {
      this.update(nextProps);
      return false;
    }
  }, {
    key: 'on',
    value: function on() {
      for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      return this.simplemde.codemirror.on.apply(this.simplemde.codemirror, args);
    }
  }, {
    key: 'off',
    value: function off() {
      for (var _len2 = arguments.length, args = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
        args[_key2] = arguments[_key2];
      }

      return this.simplemde.codemirror.off.apply(this.simplemde.codemirror, args);
    }
  }, {
    key: 'text',
    value: function text(value) {
      if (this.simplemde.isPreviewActive() && value !== undefined) {
        var wrapper = this.simplemde.codemirror.getWrapperElement();
        var preview = wrapper.lastChild;
        preview.innerHTML = _ques2.default.render(value);
      }
      return this.simplemde.value.call(this.simplemde, value);
    }
  }, {
    key: 'html',
    value: function html() {
      return _ques2.default.render(this.text());
    }
  }, {
    key: 'updateValue',
    value: function updateValue(nextProps) {
      if (nextProps.value !== this.text()) {
        this.text(nextProps.value);
      }
    }
  }, {
    key: 'updateToolbar',
    value: function updateToolbar(nextProps) {
      if (JSON.stringify(this.props.toolbar) !== JSON.stringify(nextProps.toolbar) || this.props.guide !== nextProps.guide || this.props.lng !== nextProps.lng || this.props.uploader !== nextProps.uploader) {
        var toolbar = nextProps.toolbar || defaultOptions.toolbar;
        var simplemde = this.simplemde;
        var wrapper = simplemde.codemirror.getWrapperElement();

        if (nextProps.guide) {
          toolbar = toolbar.concat(['|', 'guide']);
        }
        var buttons = (0, _buttons.getButtons)(toolbar, {
          lng: nextProps.lng,
          uploader: nextProps.uploader,
          guide: nextProps.guide
        });

        if (simplemde.gui.toolbar) {
          wrapper.parentNode.removeChild(simplemde.gui.toolbar);
        }
        simplemde.gui.toolbar = simplemde.createToolbar(buttons);
      }
    }
  }, {
    key: 'updateName',
    value: function updateName(nextProps) {
      var inputArea = _reactDom2.default.findDOMNode(this.refs.inputArea);
      if (inputArea.name !== nextProps.name) {
        inputArea.name = nextProps.name;
      }
    }
  }, {
    key: 'update',
    value: function update(nextProps) {
      this.updateToolbar(nextProps);
      this.updateValue(nextProps);
      this.updateName(nextProps);
    }
  }, {
    key: 'render',
    value: function render() {
      return _react2.default.createElement(
        'div',
        { className: 'pta-editor' },
        _react2.default.createElement('textarea', { ref: 'inputArea', name: this.props.name })
      );
    }
  }, {
    key: 'value',
    set: function set(data) {
      if (this.text() !== data) {
        this.text(data);
      }
    },
    get: function get() {
      return this.text();
    }
  }]);

  return Editor;
}(_react2.default.Component);

exports.default = Editor;


Editor.propTypes = {
  guide: _propTypes2.default.string,
  lng: _propTypes2.default.string,
  name: _propTypes2.default.string,
  onChange: _propTypes2.default.func,
  simplemde: _propTypes2.default.object,
  toolbar: _propTypes2.default.array,
  uploader: _propTypes2.default.func,
  value: _propTypes2.default.string
};

Editor.defaultProps = {
  simplemde: {}
};

var render = exports.render = Editor.render = _ques2.default.render;