import i18next from 'i18next'
import LanguageDetector from 'i18next-browser-languagedetector'

import en from '../lib/locals/en.json'
import zhCN from '../lib/locals/zh-CN.json'

const i18n = i18next
  .createInstance({})
  .use(LanguageDetector)
  .init({
    fallbackLng: 'en',
    ns: ['buttons'],
    resources: {
      en,
      'zh-CN': zhCN,
    },
  })

export default i18n
