## Markdown 基本格式

### 标题
```
h1
======

# h1
## h2
### h3
#### h4
##### h5
###### h6
```

显示效果如下：

h1
======

# h1
## h2
### h3
#### h4

### 换行
两个以上的空格加回车。

### 链接
```
跳转到[网易](http://www.163.com)
[返回首页](index.html)
直接一个链接：&lt;http://www.126.com&gt;
```

显示效果如下：

跳转到[网易](http://www.163.com 网易)
[返回首页](index.html)
直接一个链接：<http://www.126.com>

### 图片
```
![图片描述](http://图片链接)
```

### 列表
有序列表

```
1. 第一个
    1. 第1.1个
2. 第二个
3. 第三个
```

显示效果如下：

1. 第一个
    1. 第1.1个
2. 第二个
3. 第三个

无序列表

```
- 葡萄
- 苹果
    - 富士
    - 红五星
- 梨
```

显示效果如下：

- 葡萄
- 苹果
    - 富士
    - 红五星
- 梨

### 强调
```
**强调内容**
```

显示效果如下：

**强调内容**

### 斜体
```
*斜体内容*
```

显示效果如下：

*斜体内容*

### 删除线
```
~~删除线~~
```

显示效果如下：

~~删除线~~

### 分割线
```
----
```

显示效果如下：

----

### 行内代码
```
`npm install`
```

显示效果如下：

`npm install`

### 块级代码
````
```js
function say(str) {
    console.log(str);
}
```

```css
.main {
    width: 80%;
    margin: 20px auto;
}
```
````

显示效果如下：
```js
function say(str) {
  console.log(str);
}
```

```css
.main {
  width: 80%;
  margin: 20px auto;
}
```

### 表格
```
| Tables      | Are      | Cool   |
|:----------- |:--------:| ------:|
| 左对齐      | 居中对齐 | 右对齐 |
| test        | abcd     | 3.20   |
```

显示效果如下：

| Tables      | Are      | Cool   |
|:----------- |:--------:| ------:|
| 左对齐      | 居中对齐 | 右对齐 |
| test        | abcd     | 3.20   |

### 引用
```
> 天才就是99%的努力加上1%的灵感。——爱迪生
```

显示效果如下：

> 天才就是99%的努力加上1%的灵感。——爱迪生

### 转义
如果不想使用Markdown的特殊字符可以使用转义。

```
\*sth\*
```

显示效果如下：

\*sth\*

------
